// Ejemplo de programa para variar la velocidad del 
//  motor de la correa (Lazo abierto) 
//
//  ESP32 Dev Module, 38 pines
//
//  Board manager:  esp32 Espressif 3.0.7
//
//   fecha: 9 de diciembre del 2024

#include "RotaryEncoderPCNT.h"
#define ENCODER_A 13// Pin for Encoder A
#define ENCODER_B 25 // Pin for Encoder B

// Definir los pines de control del puente H Correa
const int in1Pin = 19; // conexion IN1 del puente H (para la dirección)
const int in2Pin = 18; // conexion IN2 del puente H (para la dirección)
const int pwmPin = 21; // Pin para la señal PWM (control de velocidad)

// Definir la frecuencia y resolución del PWM
const int freq = 2000; // Frecuencia PWM en Hz
const int resolution = 8; // Resolución de 8 bits (0-255)
const int pwmChannel = 0; // Canal PWM

hw_timer_t *Timer0_Cfg = NULL;

unsigned long vel1,vel2,vel3;
int aa,dato1;

RotaryEncoderPCNT encoder(ENCODER_A,ENCODER_B);

void IRAM_ATTR Timer0_ISR() {
  vel1 = encoder.position();
  delayMicroseconds(20);
  vel2 = encoder.position();
  delayMicroseconds(20);
  vel3 = encoder.position();
  delayMicroseconds(20);

  //Serial.println("TTT");  // NO ES POSIBLE TENER SERIAL PRINT AQUI EN LA INTERRUPCION

  encoder.zero();
  //encoder_value = 0;

}


void setup() {

// **** Configura Entradas de los Encoders
  pinMode(ENCODER_A, INPUT_PULLUP);
  pinMode(ENCODER_B, INPUT_PULLUP);
  
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(pwmPin, OUTPUT);

  digitalWrite(in1Pin, HIGH); // IN1 motor correa
  digitalWrite(in2Pin, LOW); // IN2 motor correa
  ledcAttachChannel(pwmPin, freq, resolution, pwmChannel);

  // Configuración del timer utilizando la nueva API
  Timer0_Cfg = timerBegin(10000); // Configurar timer con frecuencia de 10 kHz
  timerAttachInterrupt(Timer0_Cfg, &Timer0_ISR); // Vincular ISR al timer
  timerAlarm(Timer0_Cfg, 500,true, 0); // Configurar alarma: nn ms, auto-reload
  //timerStart(Timer0_Cfg);

  Serial.begin(115200);
}

void loop(){
 unsigned long vel;

 if (Serial.available()) {
    aa = Serial.parseInt();
  }
 if (aa != 0) dato1 = aa; // setpoint banda

  ledcWrite(pwmPin,abs(dato1));
  vel=(vel1+vel2+vel3)/3; 
   //timerWrite(Timer0_Cfg, 0);  //reset timer 
   Serial.print(dato1/255.0);
   Serial.print(",");
   Serial.println(vel/472.0);

  delay(10);
}
